; Snake 2K version
; by Tognon Stefano
; (C) 2001 Ice Team
; version 1.00

; Well, I like this competition!!!
; This is my second game for C64
; It can look like a 1983 game :)

; this program is not relocatable: I put the chars definitions into a boundary
; page to reduce the code to move them; the sprites are in the rigth position too.

; look in the code: there are secret features

 ;=================================
 ; PRG start address
 ;=================================
 .byte $84,$0D

.org 3460

RED       = 150       ; 1 + red
GREEN     = 153       ; 1 + green
BLUE      = 31
WHYTE     = 5
L_RIGTH   = 39        ; rigth limit of the area
N_GROWN   = 4         ; rate of snake grown
SP_BORDER = 71        ; simbol of border for poke
SP_APPLE  = 67        ; simbol of apple for poke
SPEED     = 8         ; speed of snake
N_APPLE   = 8         ; initial number of apples + 1
T_APPLE   = 7+6+10+5  ; total number of apples to eat
POSX      = 105       ; x pos of sprites
POSY      = 132       ; y pos of sprites

SECRET     = $02      ; secret flag
length2    = $a7      ; length of note
delay2     = $a8      ; delay of note
seqIndex2  = $a9      ; seq index of note
OLDDIR     = $9b      ; old direction
TMPDIR     = $9c      ; tmp direction
ASPEED     = $AA      ; actual speed
TAPPLE     = $AB      ; total number of apples to eat
MAX_APPLE  = $B1      ; mux number of apple (decresing while in the game)
SX_START   = $B2      ; address to the start of snake positions x
SX_END     = $B4      ; address to the end of snake positions x
SY_START   = $B6      ; address to the start of snake positions y
SY_END     = $B8      ; address to the end of snake positions y
DIRECTION  = $BA      ; direction of the snake: 1 up, 2 dn, 4 sx, 8 dx
APPLE      = $BB      ; number of apple currently in the screen
TIMER      = $BC      ; timer for delay
TEMP       = $BD
GO         = $BE      ; go flag (1=go)
GROWN      = $BF      ; grown of the snake / temp variable

SET_COOR   = $E50C    ; set x/y coord
PUT_CHAR   = $E716    ; put a char in the screen
LINE       = $E9F0    ; calculate current line address
SCREEN     = $E544    ; clean the screen
STRING     = $AB1E    ; put a string

freqHiSeq2:                       ; freq high sequence for voice 2
  .byte $26, $22, $26, $1C, $16, $1C, $13
  .byte $26, $22, $26, $1C, $16, $1C, $13, $26
  .byte $2B, $2D, $2B, $2D, $26, $2B, $26, $2B
  .byte $22, $26, $22, $1C, $22, $26, $26, $22
  .byte $26, $1C, $16, $1C, $13, $26, $22, $26
  .byte $1C, $16, $1C, $13, $26, $2B, $2D, $2B
  .byte $2D, $26, $2B, $26, $2B, $22, $26, $22
  .byte $26, $2B, $2D, $39, $33, $39, $2B, $22
  .byte $2B, $1C, $39, $33, $39, $2B, $22, $2B
  .byte $1C, $39, $40, $44, $40, $44, $39, $40
  .byte $39, $40, $33, $39, $33, $2B, $33, $39
  .byte $39, $33, $39, $2B, $22, $2B, $1C, $39
  .byte $33, $39, $2B, $22, $2B, $1C, $39, $40
  .byte $44, $40, $44, $39, $40, $39, $40, $33
  .byte $39, $33, $39, $40, $44

freqLoSeq2:                       ; freq low sequence for voice 2
  .byte $7E, $48, $7E, $D6, $E8, $D6, $3F
  .byte $7E, $48, $7E, $D6, $E8, $D6, $3F, $7E
  .byte $34, $C6, $34, $C6, $7E, $34, $7E, $34
  .byte $48, $7E, $48, $D6, $48, $7E, $7E, $48
  .byte $7E, $D6, $E8, $D6, $3F, $7E, $48, $7E
  .byte $D6, $E8, $D6, $3F, $7E, $34, $C6, $34
  .byte $C6, $7E, $34, $7E, $34, $48, $7E, $48
  .byte $7E, $34, $C6, $AC, $61, $AC, $34, $48
  .byte $34, $D6, $AC, $61, $AC, $34, $48, $34
  .byte $D6, $AC, $BC, $95, $BC, $95, $AC, $BC
  .byte $AC, $BC, $61, $AC, $61, $34, $61, $AC
  .byte $AC, $61, $AC, $34, $48, $34, $D6, $AC
  .byte $61, $AC, $34, $48, $34, $D6, $AC, $BC
  .byte $95, $BC, $95, $AC, $BC, $AC, $BC, $61
  .byte $AC, $61, $AC, $BC, $95

char:
SC_HUP = 96
  .byte $1C                       ; __oo**__
  .byte $1C                       ; __oo**__
  .byte $9E                       ; uuoo**uu
  .byte $9E                       ; uuoo**uu
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****

SC_HDN = 97

  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $9E                       ; uuoo**uu
  .byte $9E                       ; uuoo**uu
  .byte $1C                       ; __oo**__
  .byte $1C                       ; __oo**__

SC_SX = 98
  .byte $25                       ; __uuoooo
  .byte $25                       ; __uuoooo
  .byte $55                       ; oooooooo
  .byte $55                       ; oooooooo
  .byte $FF                       ; ********
  .byte $FF                       ; ********
  .byte $2F                       ; __uu****
  .byte $2F                       ; __uu****

SC_APPLE = 99
  .byte $10                       ;  __oo___
  .byte $04                       ;  ____oo__
  .byte $3C                       ;  __****
  .byte $BE                       ;  uu****uu
  .byte $FF                       ;  ********
  .byte $FF                       ;  ********
  .byte $BF                       ;  uu****uu
  .byte $3C                       ;  __****__

SC_DX = 100
  .byte $58                       ; oooouu__
  .byte $58                       ; oooouu__
  .byte $55                       ; oooooooo
  .byte $55                       ; oooooooo
  .byte $FF                       ; ********
  .byte $FF                       ; ********
  .byte $F8                       ; ****uu__
  .byte $F8                       ; ****uu__

SC_ORR = 101
  .byte $55                       ; OOOOOOOO
  .byte $55                       ; 00000000
  .byte $55                       ; 00000000
  .byte $55                       ; 00000000
  .byte $FF                       ; ********
  .byte $FF                       ; ********
  .byte $FF                       ; ********
  .byte $FF                       ; ********

SC_VERT = 102
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****

SC_BORDER = 103
  .byte $FF                       ; **********
  .byte $81                       ; *________*
  .byte $81                       ; *________*
  .byte $81                       ; *________*
  .byte $81                       ; *________*
  .byte $81                       ; *________*
  .byte $81                       ; *________*
  .byte $FF                       ; **********

SC_D1 = 104
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $5F                       ; oooo****
  .byte $FF                       ; ********
  .byte $FF                       ; ********
  .byte $FF                       ; ********
  .byte $FC                       ; ******__

SC_D2 = 105
  .byte $15                       ; __OOOOOO
  .byte $55                       ; OOOOOOOO
  .byte $55                       ; OOOOOOOO
  .byte $55                       ; OOOOOOOO
  .byte $5F                       ; OOOO****
  .byte $5F                       ; OOOO****
  .byte $5F                       ; OOOO****
  .byte $5F                       ; OOOO****

SC_D3 = 106
  .byte $54                       ; oooooo__
  .byte $57                       ; oooooo**
  .byte $5F                       ; oooo****
  .byte $7F                       ; oo******
  .byte $FF                       ; ********
  .byte $DF                       ; **oo****
  .byte $DF                       ; **oo****
  .byte $5F                       ; oooo****

SC_D4 = 107
  .byte $5F                       ; oooo****
  .byte $5D                       ; oooo**oo
  .byte $5D                       ; oooo**oo
  .byte $5F                       ; oooo****
  .byte $5F                       ; oo******
  .byte $5F                       ; oo******
  .byte $FF                       ; ********
  .byte $3F                       ; __******

lengthSeq2:                       ; note length sequence for voice 2
  .byte $0A, $0A, $0A, $0A, $0A, $0A, $19
  .byte $0A, $0A, $0A, $0A, $0A, $0A, $19, $0A
  .byte $0A, $0A, $0A, $0A, $0A, $0A, $0A, $0A
  .byte $0A, $0A, $0A, $0A, $0A, $19, $0A, $0A
  .byte $0A, $0A, $0A, $0A, $19, $0A, $0A, $0A
  .byte $0A, $0A, $0A, $19, $0A, $0A, $0A, $0A
  .byte $0A, $0A, $0A, $0A, $0A, $0A, $0A, $0A
  .byte $0A, $0A, $19, $0A, $0A, $0A, $0A, $0A
  .byte $0A, $19, $0A, $0A, $0A, $0A, $0A, $0A
  .byte $19, $0A, $0A, $0A, $0A, $0A, $0A, $0A
  .byte $0A, $0A, $0A, $0A, $0A, $0A, $0A, $19
  .byte $0A, $0A, $0A, $0A, $0A, $0A, $19, $0A
  .byte $0A, $0A, $0A, $0A, $0A, $19, $0A, $0A
  .byte $0A, $0A, $0A, $0A, $0A, $0A, $0A, $0A
  .byte $0A, $0A, $0A, $0A, $19

mob_IC:
  .byte 170, 0, 0, 170, 16, 0, 40, 16, 0
  .byte 40, 80, 0, 40, 80, 243, 40, 67, 255
  .byte 40, 79, 255, 40, 79, 15, 40, 79, 16
  .byte 40, 79, 17, 40, 79, 16, 40, 79, 16
  .byte 40, 79, 0, 40, 79, 207, 40, 79, 255
  .byte 40, 67, 255, 170, 0, 255, 170, 17, 0
  .byte 0, 16, 85, 21, 80, 21, 5, 80, 0, 0

mob_E:
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 40, 0, 64, 170, 16
  .byte 18, 170, 132, 18, 128, 132, 18, 132, 132
  .byte 66, 128, 132, 2, 170, 132, 2, 170, 132
  .byte 2, 128, 20, 2, 132, 128, 18, 128, 132
  .byte 16, 170, 132, 16, 42, 4, 64, 64, 16
  .byte 64, 21, 80, 0, 5, 64, 0, 0, 0, 0

mob_TEAM:
  .byte 228, 200, 0, 74, 47, 128, 78, 106, 128
  .byte 72, 170, 128, 76, 234, 128, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

; here must be 4096

; init (called only one time)
      sei
      lda  #<irqR
      sta  $0314
      lda  #>irqR
      sta  $0315
      cli

      ldx  #$00
      stx  53280
      stx  SY_END                  ; this is the dest. address for char move op.
      stx  SX_END                  ; this is the source
                                   ; next instruction is moved for saving a byte

                                   ; init music
      lda  #$08
      sta  length2
      sta  delay2
      lda  #$FF
      sta  seqIndex2

      lda  #$0F
      sta  $D418                  ; Select volume and filter mode
      lda  #$11
      sta  $D40C                  ; Generator 2: Attack/Decay
      sta  $D405
      lda  #$00
      sta  $D40D                  ; Generator 2: Sustain/Release
      sta  $D406

      lda  #129
      sta  54272+18
      sta  54272+14
      sta  54273+14
                                  ; transfer characters codes to 14336
      lda  #254
      and  $DC0E
      sta  $DC0E
      lda  #251
      and  $01
      sta  $01
                                  ; set pointers
      lda  #$38
      sta  SY_END+1
      lda  #$D0
      sta  SX_END+1
copy:                             ; copy the chars
      lda  (SX_END,x)
      sta  (SY_END,x)
      inc  SX_END
      inc  SY_END
      bne  copy
      inc  SX_END+1
      inc  SY_END+1
      lda  SY_END+1
      cmp  #$40
      bne  copy
                                  ; set pointers
      lda  #<char
      sta  SX_END
      lda  #>char
      sta  SX_END+1
      lda  #$00                   ; from char 64
      sta  SY_END
      lda  #$3A
      sta  SY_END+1
copy2:                            ; put the new chars
      lda  (SX_END,x)
      sta  (SY_END,x)
      inc  SX_END
      inc  SY_END
      bne  copy2

                                  ; restore pcr
      lda  #04
      ora  $01
      sta  $01
      lda  #01
      ora  $DC0E
      sta  $DC0E
                                  ; switch to new chars
      lda  #31
      sta  $D018

      inx
      stx  53281
                                  ; MCM char mode
      lda  #$10
      ora  $D016
      sta  $D016
                                  ; init color of MCM
      ldx  #13                    ; light green
      stx  $D022
      lda  #10                    ; ligth red
      sta  $D023

                                  ; init logo sprites
      stx  $D026                  ; mob multicolor 1
      inx
      stx  $D027                  ; mob 0 color
      inx
      stx  $D025                  ; mob multi color 0
      stx  $D029                  ; mob 2 color

      ldx  #$03                   ; set 0 and 1 as multicolor
      stx  $D01C
      dex
      stx  $D028                  ; red color for mob 1
                                  ; insert sprite pointer to 3094
      ldx  #61
      stx  2040
      inx
      stx  2041
      inx
      stx  2042
                                  ; x/y pos of mob 1
      ldx  #POSX
      stx  $D000
      ldy  #POSY
      sty  $D001
                                  ; x/y pos of mob 2
      ldx  #POSX+24
      stx  $D002
      sty  $D003
                                  ; x/y pos of mob 3
      ldx  #POSX+21
      stx  $D004
      dey
      dey
      sty  $D005
                                  ; show sprites
      lda  #$07
      sta  $D015

      lda  #BLUE
      jsr  PUT_CHAR

      jsr  SCREEN
                                  ; show a presentation screen

                                  ; make the left vertical line
      ldy  #5
loopL1:
      ldx  #20
loopLv1:
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_BORDER
      jsr  PUT_CHAR               ; put a char
      dex
      cpx  #3
      bne  loopLv1

                                  ; make the rigth vertical line
      cpy  #5
      bne  nextL1
      ldy  #34
      jmp  loopL1

                                  ; top line in this format: #######
nextL1:
      ldx  #29
      lda  #SP_BORDER
loopT4:
      sta  1024+125,x
      dex
      bpl  loopT4

                                   ;bottom line
      ldx  #29
loopT5:
      sta  1904-40+5,x
      dex
      bpl  loopT5
                                   ; insert some strings
      ldx  #09
      ldy  #19
      jsr  SET_COOR
      lda  #<Spres
      ldy  #>Spres
      jsr  STRING

      ldx  #11
      ldy  #19
      jsr  SET_COOR
      lda  #<Ssnake
      ldy  #>Ssnake
      jsr  STRING

      ldx  #13
      ldy  #19
      jsr  SET_COOR
      lda  #<Sgame
      ldy  #>Sgame
      jsr  STRING

      ldx  #16
      ldy  #9
      jsr  SET_COOR
      lda  #<Sput
      ldy  #>Sput
      jsr  STRING

      ldx  #18
      ldy  #15
      jsr  SET_COOR
      lda  #<Sfire
      ldy  #>Sfire
      jsr  STRING
                                  ; now insert a row with a snake and apple
      lda  #RED
      jsr  PUT_CHAR
      ldx  #6
      ldy  #10
      jsr  SET_COOR
      lda  #SC_APPLE
      jsr  PUT_CHAR

      lda  #GREEN
      jsr  PUT_CHAR
      lda  #32
      jsr  PUT_CHAR
      lda  #SC_SX
      jsr  PUT_CHAR

      ldx  #17
repeatCode:
      lda  #SC_ORR
      jsr  PUT_CHAR
      dex
      bne  repeatCode

      jsr  fire

      lda  #$00
      sta  SECRET                  ; no secret features to activate

      lda  #$01
      bit  $DC01
      bne  noSecret1

      sta  SECRET                 ; activate secret feature 1

noSecret1:
      lda  #$08
      bit  $DC01
      bne  noSecret2

      ora  SECRET                 ; activate secret feature 2
      sta  SECRET

noSecret2:
                                  ; hidden sprites
      lda  #$00
      sta  $D015

      lda  #SPEED
      sta  TIMER
      sta  ASPEED
MainLoop:                         ; start/restart the game

      lda  #BLUE
      jsr  PUT_CHAR               ; perimether is blue
      jsr  SCREEN                 ; clear the screen

; make the left vertical line
      ldy  #00
loopL:
      ldx  #24
loopLv:
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_BORDER
      jsr  PUT_CHAR               ; put a char
      dex
      bpl  loopLv

; make the rigth vertical line
      cpy  #00
      bne  nextL
      ldy  #L_RIGTH
      jmp  loopL

; top line in this format: #######
nextL:
      ldx  #L_RIGTH
      lda  #SP_BORDER
loopT1:
      sta  1024+80,x
      dex
      bpl  loopT1

;bottom line
      ldx  #L_RIGTH
loopT2:
      sta  1984,x
      dex
      bpl  loopT2
                                  ; insert string in top of the area
      ldx  #01
      ldy  #10
      jsr  SET_COOR
      lda  #<Ssnake
      ldy  #>Ssnake
      jsr  STRING

; init the data of the x/y snake positions
initData:
      lda  #$30
      sta  SX_END+1               ; position to $30xx
      sta  SX_START+1
      lda  #$70
      sta  SY_END+1               ; position to $70xx
      sta  SY_START+1
      lda  #$00
      sta  SX_END
      sta  SY_END
      lda  #$02
      sta  SX_START
      sta  SY_START

insertSnake:                      ; insert the snake in the area
      ldx  #20
      ldy  #$00
      lda  #1
      sta  (SX_END),y
      txa
      sta  (SY_END),y
      sta  (SY_START),y
      lda  #3
      sta  (SX_START),y
      iny
      lda  #2
      sta  (SX_END),y
      txa
      sta  (SY_END),y

      ldy  #20
      ldx  #3
      jsr  SET_COOR               ; set x/y coord
      lda  #GREEN
      jsr  PUT_CHAR               ; color green for the snake

      lda  #SC_HDN
      jsr  PUT_CHAR               ; put a char

      dex
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_VERT
      jsr  PUT_CHAR               ; put a char
      dex
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_VERT
      jsr  PUT_CHAR               ; put a char

; insert a random block in the area
      lda  #BLUE
      jsr  PUT_CHAR               ; block is blue

      lda  #$08                   ; look for secret 2
      bit  SECRET
      bne  endBlock

      lda  54272+27               ; generate a random number of blocks
      and  #$07                   ; use 8 values
      adc  #$04

insertBlock:
      pha
      lda  54272+27               ; read a random number
      and  #$1F                   ; use 32 values
      adc  #$03                   ; compensate
      tay
      lda  54272+27
      and  #$0F                   ; use 16 values
      adc  #$05                   ; compensate
      tax

      jsr  SET_COOR
      lda  #SC_BORDER
      jsr  PUT_CHAR
      jsr  PUT_CHAR
      jsr  PUT_CHAR

      pla
      tax
      dex
      txa
      bne  insertBlock

endBlock:
      ldx  #$01
      ldy  #27
      jsr  SET_COOR
      lda  #<Sfire
      ldy  #>Sfire
      jsr  STRING                 ; write a string

      jsr  fire                   ; attend a fire from user

                                  ; be sure to position the apple in the free

; init other variables
      lda  #$00
      sta  GO
      sta  GROWN
      sta  APPLE
      ldx  #02
      stx  DIRECTION
      stx  OLDDIR
      lda  #N_APPLE
      sta  MAX_APPLE
      lda  #T_APPLE
      sta  TAPPLE

LocalLoop:                        ; loop for controlling the game

                                  ;show points
      ldx  #$01
      ldy  #27
      jsr  SET_COOR
      lda  #BLUE
      jsr  PUT_CHAR
      ldx  TAPPLE
      lda  #0
      jsr  $BDCD                  ; put a integer as string
                                  ; erase some char after the string
      lda  #<Sspace
      ldy  #>Sspace
      jsr  STRING

LocalLoop1:
      lda  GO
      beq  LocalLoop1
      dec  GO

; look for apple
      lda  APPLE
      bne  alreadyApple

      dec  MAX_APPLE
      bne  repeat
      jmp  youWin

; insert a random position apple
repeat:
      lda  54272+27               ; read a random number
      and  #$1F                   ; use 32 values
      adc  #$04                   ; compensate
      tay
      lda  54272+27
      and  #$0F                   ; use 16 values
      adc  #$04                   ; compensate
      tax

      jsr  SET_COOR
                                  ; be sure to position the apple in the free
      jsr  LINE
      lda  ($D1),y
      cmp  #32
      bne  repeat

      lda  #RED
      jsr  PUT_CHAR               ; color the apple in red

      lda  #SC_APPLE
      jsr  PUT_CHAR
                                  ; inset all the max apple
      inc  APPLE
      lda  APPLE
      cmp  MAX_APPLE
      bne  repeat

alreadyApple:

; move the head of the snake using direction
      ldx  #$00
      lda  (SY_START,x)
      tay
      pha
      lda  (SX_START,x)
      tax
      pha
                                  ; look for direction
      lda  #$01
      bit  DIRECTION
      beq  skipUp
      dex
skipUp:
      asl  a
      bit  DIRECTION
      beq  skipDn
      inx
skipDn:
      asl  a
      bit  DIRECTION
      beq  skipSx
      dey
skipSx:
      asl  a
      bit  DIRECTION
      beq  skipDx
      iny
skipDx:
      jsr  SET_COOR
                                  ; read the char in the position to go
      jsr  LINE
      lda  ($D1),y

      cmp  #SP_APPLE
      bne  other

maxGrown:
      lda  #N_GROWN
      sta  GROWN
      dec  APPLE
      dec  TAPPLE                 ; decrease total apples to eat
      jmp  redrawSnake

other:
      cmp  #32
      beq  redrawSnake
      jmp  Died

redrawSnake:
      lda  #GREEN
      jsr  PUT_CHAR               ; color the snake in green

      lda  OLDDIR
      sta  TMPDIR                 ; store for next use                                  ; make the snake head using direction
      lda  DIRECTION
      sta  OLDDIR
      lsr
      clc
      adc  #SC_HUP
      jsr  PUT_CHAR
                                  ; read body position to update

                                  ; update pointers
      inc  SX_START
      inc  SY_START
      bne  skipIncS
      inc  SX_START+1
      inc  SY_START+1
skipIncS:
      txa
      ldx  #$00
      sta  (SX_START,x)
      tya
      sta  (SY_START,x)

      pla
      tax
      pla
      tay
      jsr  SET_COOR

      ldx  #SC_VERT
      lda  TMPDIR                 ; read old direction
      bit  DIRECTION
      beq  changeDir

      cmp  #$03
      bmi  isVert

      dex                         ; orrizontal direction
isVert:
      txa
      bne  putBody

changeDir:
                                  ; trasform old in relative
      cmp  #3
      bmi  rev1

      eor  #$0c
      bne  rev2
rev1:
      eor  #$03
rev2:
      clc
      adc  DIRECTION
      cmp  #06                    ; 2 to 4 or 4 to 2 direction
      bne  next1

      lda  #SC_D3
      jmp  putBody

next1:
      cmp  #09                    ; 8 to 1 or 1 to 8 direction
      bne  next2

      lda  #SC_D4
      jmp  putBody

next2:
      cmp  #10                    ; 2 to 8 or 8 to 2 direction
      bne  next3

      lda  #SC_D2
      jmp  putBody

next3:
      lda  #SC_D1

putBody:
      jsr  PUT_CHAR

      lda  GROWN
      beq  removeEnd

      dec  GROWN
      jmp  LocalLoop

; remove the end of the snake
removeEnd:
      ldx  #$00
      lda  (SY_END,x)
      tay
      lda  (SX_END,x)
      tax
      jsr  SET_COOR               ; set x/y coord
      lda  #32
      jsr  PUT_CHAR
                                  ; increment pointers
      inc  SX_END
      inc  SY_END
      bne  skipInc
      inc  SX_END+1
      inc  SY_END+1
skipInc:
                                  ; insert the barrier where start the snake
      ldx  #2
      ldy  #20
      jsr  SET_COOR
      lda  #BLUE
      jsr  PUT_CHAR
      lda  #SC_BORDER
      jsr  PUT_CHAR

      jmp  LocalLoop

Died:
      pla
      pla
      lda  #SPEED
      sta  ASPEED

      lda  #BLUE                     ; this is necessary for have it blue in
      jsr  PUT_CHAR                  ; all the case

      ldx  #$01
      ldy  #27
      jsr  SET_COOR
      lda  #<Slose
      ldy  #>Slose
      jsr  STRING                   ; write a string
      jmp  loopDelay

youWin:
                                    ; look for secret 1
      lda  #$01
      bit  SECRET
      beq  skipSecret1

      inc  maxGrown+1

skipSecret1:
      dec  ASPEED                   ; now it is more difficult
      ldx  #01
      ldy  #27
      jsr  SET_COOR
      lda  #<Swin
      ldy  #>Swin
      jsr  STRING                   ; write a string
loopDelay:
      jsr  $EEB3                    ; delay
      jsr  $EEB3                    ; delay
      jsr  $EEB3                    ; delay
      dex
      bne  loopDelay
      jmp  MainLoop

; interrupt routine
irqR:
      php
      pha
      dec  TIMER
      bne  jumpIRQ
      inc  GO
      lda  ASPEED
      sta  TIMER

jumpIRQ:
      ; look for direction
      lda  $DC01
      eor  #$FF
      sta  TEMP

      lda  #$01                   ; test for up
      bit  TEMP
      bne  setting
notUp:
      asl  a                      ; test for dn
      bit  TEMP
      bne  setting
notDn:
      asl  a
      bit  TEMP
      bne  setting
notSx:
      asl  a
      bit  TEMP
      beq  notSetting
notDx:
setting:
      sta  DIRECTION
notSetting:

; now play music
      txa
      pha

playMain:
      dec  length2
      lda  length2
      cmp  #$FF
      bne  exitMusic

      lda  #$00
      sta  length2
      sta  $D40B                  ; Voice 2: Control registers
      sta  $D404

      dec  delay2
      bne  exitMusic
      inc  seqIndex2
      lda  seqIndex2
      cmp  #$74                   ; end of sequence 2?
      bne  noEndSeq2
      lda  #$00                   ; reset to start sequence
      sta  seqIndex2
                                  ; play next note in the sequence
noEndSeq2:
      tax

      lda  #$0F
      sta  $D418                  ; Select volume and filter mode


      lda  freqLoSeq2,x
      sta  $D407                  ; Voice 2: Frequency control (lo byte)
      sta  $D400
      lda  freqHiSeq2,x
      sta  $D408                  ; Voice 2: Frequency control (hi byte)
      sta  $D401

      lda  #$11
      sta  $D40B                  ; Voice 2: Control registers
      lda  #$21
      sta  $D404


      lda  lengthSeq2,x
      sta  length2
      lda  #$04
      sta  delay2
exitMusic:

      pla
      tax

      pla
      plp
      jmp  $EA32

Swin:
  .byte "YOU WIN...", 0
Slose:
  .byte "YOU LOSE",0
Ssnake:
  .byte "SNAKE",0
Spres:
  .byte "PRESENT:",0
Sfire:
  .byte "PRESS FIRE",0
Sgame:
  .byte "A 2K MINIGAME",0
Sput:
  .byte "PUT JOYSTICK IN PORT 1",0
Sspace:
  .byte "         ",0

fire:                             ; press fire to go
                                  ; hidden the cursor
      lda  #WHYTE
      jsr  PUT_CHAR
fire1:
      lda  #$10
      bit  $DC01
      bne  fire1
      rts





